/*
 *  Copyright 2019-2020 Zheng Jie
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *  http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 */
package com.youchain.basicdata.service;

import com.youchain.basicdata.domain.Box;
import com.youchain.basicdata.domain.Item;
import com.youchain.basicdata.domain.Point;
import com.youchain.basicdata.domain.Stock;
import com.youchain.basicdata.service.dto.BoxDto;
import com.youchain.basicdata.service.dto.BoxQueryCriteria;
import com.youchain.basicdata.service.dto.PointDto;
import com.youchain.businessdata.domain.Task;
import org.springframework.data.domain.Pageable;

import java.util.Map;
import java.util.List;
import java.io.IOException;
import javax.servlet.http.HttpServletResponse;

/**
 * @author huojin
 * @website https://eladmin.vip
 * @description 服务接口
 * @date 2023-08-17
 **/
public interface BoxService {

    /**
     * 查询数据分页
     *
     * @param criteria 条件
     * @param pageable 分页参数
     * @return Map<String, Object>
     */
    Map<String, Object> queryAll(BoxQueryCriteria criteria, Pageable pageable);

    /**
     * 查询所有数据不分页
     *
     * @param criteria 条件参数
     * @return List<BoxDto>
     */
    List<BoxDto> queryAll(BoxQueryCriteria criteria);

    /**
     * 根据ID查询
     *
     * @param id ID
     * @return BoxDto
     */
    BoxDto findById(Long id);

    /**
     * 创建
     *
     * @param resources /
     * @return BoxDto
     */
    BoxDto create(Box resources);

    /**
     * 编辑
     *
     * @param resources /
     */
    void update(Box resources);

    /**
     * 多选删除
     *
     * @param ids /
     */
    void deleteAll(Long[] ids);

    /**
     * 导出数据
     *
     * @param all      待导出的数据
     * @param response /
     * @throws IOException /
     */
    void download(List<BoxDto> all, HttpServletResponse response) throws IOException;

    /**
     * 根据物料ID查询按钮盒
     *
     * @param ItemId
     * @return
     */
    Box getBoxByItem(long ItemId);

    /**
     * 根据按钮盒编号查询按钮盒
     *
     * @param code
     * @return
     */
    Box getBoxByCode(String code);

    Box toEntity(BoxDto boxDto);

    void refreshPointStatus();

    /**
     * 根据点位编号、物料编号、工单号查询按钮盒
     *
     * @param pointCode
     * @return
     */
    Box getBoxByPointCode(String pointCode);

    List<Box> queryBoxList(String areaName);

    void callBox(BoxDto boxDto);

    void callTrolley(PointDto pointDto, String pointCode);

    Task createTask(Item item, Stock stock, Point endPoint);
}
